public class AmDocs_CalloutClass_CreateUnit {
    
    public class person {
        public String tenantServiceID;
        public String orderID;
        public String responseStatus;
        public String backendErrorMessage;
        public String tenantApID;
        public String backendErrorCode;
        public cls_informationMessages[] informationMessages;
        public cls_equipmentList[] equipmentList;
    }
    
    class cls_informationMessages {
        public String errorCode;
        public String errorDescription;
    }
    
    class cls_equipmentList {
        public string action;
        public string receiverID;
    }
    
    public class ResultMessage
    {
        @AuraEnabled
        public boolean isError{get;set;}
        
        @AuraEnabled
        public String resultMessage{get;set;}
        
        //Milestone# MS-001732 - 19 June 2020 - Start
        @AuraEnabled
        public boolean isResponseNull{get;set;}
        //Milestone# MS-001732 - End
    }
    
    @AuraEnabled
    public static ResultMessage createUnit(String Id)
    {
        ResultMessage objResultMessage=new ResultMessage();
        String resultMsg='Test Message';
        
        list<Tenant_Account__c> TA = [select id, Name, City__c, State__c, Zip__c, Unit__c, Address__c, Email_Address__c, First_Name__c, Last_Name__c, Phone_Number__c, PPV__c, Opportunity__c, AmDocs_ServiceID__c from Tenant_Account__c where Id = :id AND (AmDocs_ServiceID__c = '' OR AmDocs_ServiceID__c = Null) Limit 1];
        System.debug('RESULTS of the LIST lookup to the Tenant Account object' +TA);
        
        list<Tenant_Equipment__c> T = [select id, Amdocs_Tenant_ID__c, Smart_Card__c, Name, Address__c, City__c, State__c, Zip_Code__c, Unit__c, Phone_Number__c, Email_Address__c, Customer_First_Name__c, Customer_Last_Name__c, Location__c, Action__c, Opportunity__c from Tenant_Equipment__c where Tenant_Account__c = :id  AND Action__c = 'ADD' AND Location__c = 'D'];
        System.debug('RESULTS of the LIST lookup to the Tenant Equipment object' +T);     
        
        
        String SO = [select Opportunity__c from Tenant_Account__c where Id = :id LIMIT 1 ].Opportunity__c ;
        System.debug('RESULTS of the LIST SO String to the Opp object ' +SO);
        
        list<Opportunity> O = [select id, Name, AmDocs_tenantType__c, AmDocs_ServiceID__c, AmDocs_SiteID__c, AmDocs_BarID__c, Amdocs_CustomerID__c from Opportunity where Id = :SO LIMIT 1 ];
        System.debug('RESULTS of the LIST lookup to the Opp object S From SOs ID ' +O);
        
        Datetime dt1 = System.Now();
        
        list<API_LOG__c> timer = [select Id, ServiceID__c, CreatedDate, NextAvailableActivateUpdateTime__c from API_LOG__c where ServiceID__c = :O[0].AmDocs_ServiceID__c  AND NextAvailableActivateUpdateTime__c >= :dt1 Order By NextAvailableActivateUpdateTime__c DESC Limit 1];
        
        if( (timer.size() > 0 )){
            resultMsg='Please wait 2 minutes until current timer expires and existing work orders are completed.';
            
            objResultMessage.isError=true;
            objResultMessage.isResponseNull=false;
            objResultMessage.resultMessage='Please wait 2 minutes until current timer expires and existing work orders are completed.';
        }
        else{
            list<Tenant_Product_Line_Item__c> TC = [select id, Action__c, Quantity__c, Standard_Price__c, AmDocs_Incremental_Caption__c, AmDocs_Incremental_ProductID__c, AmDocs_Individual_Caption__c, AmDocs_ProductID__c, Family__c from Tenant_Product_Line_Item__c where Tenant_Account__c = :id AND Action__c = 'ADD' AND Family__c = 'Core' LIMIT 1];
            System.debug('RESULTS of the LIST lookup to the Core OpportunityLineItem records for TC ' +TC);
            
            list<Tenant_Product_Line_Item__c> TB = [select id, Action__c, Tenant_Account__c, Quantity__c, Standard_Price__c, AmDocs_Incremental_Caption__c, AmDocs_Incremental_ProductID__c, AmDocs_Individual_Caption__c, AmDocs_ProductID__c, Family__c from Tenant_Product_Line_Item__c where Tenant_Account__c = :id AND Action__c = 'ADD' AND Family__c = 'Add-On' ];
            System.debug('RESULTS of the LIST lookup to the non-Core & non-Promotional OpportunityLineItem records for TB ' +TB);
            
            list<Tenant_Product_Line_Item__c> TP = [select id, Action__c, Quantity__c, Tenant_Account__c, Standard_Price__c, AmDocs_Incremental_Caption__c, AmDocs_Incremental_ProductID__c, AmDocs_Individual_Caption__c, AmDocs_ProductID__c, Family__c from Tenant_Product_Line_Item__c where Tenant_Account__c = :id AND Action__c = 'ADD' AND Family__c = 'Promotion' ];
            System.debug('RESULTS of the LIST lookup to the Promotional OpportunityLineItem records for TP ' +TP);
            
            list<OpportunityLineItem> C = [select id, Action__c, Quantity, Sales_Price2__c, Amdocs_ProductID__c, Family__c, Opportunity.Id from OpportunityLineItem where Opportunity.Id = :SO AND Family__c = 'Core' LIMIT 1];
            System.debug('RESULTS of the LIST lookup to the Core OpportunityLineItem records' +C);
            
            list<AmDocs_Login__c> A = [select id, UserName__c, UserPassword__c, UXF_Token__c, End_Point_Environment__c, CreatedDate from AmDocs_Login__c Order By CreatedDate DESC Limit 1 ];
            System.debug('RESULTS of the LIST lookup to the OpportunityLineItem object' +A);
            
            JSONGenerator jsonObj = JSON.createGenerator(true);
            jsonObj.writeStartObject();
            jsonObj.writeFieldName('ImplCreateTVRestInput');
            jsonObj.writeStartObject();
            if(O[0].AmDocs_ServiceID__c != null && O[0].AmDocs_tenantType__c != 'Individual') { 
                jsonObj.writeStringField('ownerServiceID', O[0].AmDocs_ServiceID__c);
                System.debug('DEBUG 001 ======== Service ID: ' + O[0].AmDocs_ServiceID__c );
            }
            jsonObj.writeStringField('reasonCode', 'CREQ');
            jsonObj.writeStringField('siteID', O[0].AmDocs_SiteID__c);
            System.debug('DEBUG 002 ======== AmDocs_SiteID: ' + O[0].AmDocs_SiteID__c );
            System.debug('DEBUG 002 ======== AmDocs_BarID: ' + O[0].AmDocs_BarID__c);
            if(!String.isEmpty(O[0].AmDocs_BarID__c))jsonObj.writeStringField('bar', O[0].AmDocs_BarID__c);
            for(Integer i = 0; i < TC.size(); i++){
                if(O[0].AmDocs_tenantType__c == 'Individual') {jsonObj.writeStringField('productOfferID', TC[i].AmDocs_ProductID__c); }
                else if(O[0].AmDocs_tenantType__c != 'Incremental') {jsonObj.writeStringField('productOfferID', TC[i].AmDocs_Incremental_ProductID__c); }}
            
            System.debug('DEBUG 003 ======== TenantType: ' + O[0].AmDocs_tenantType__c );
            for(Integer i = 0; i < TA.size(); i++){
                if(O[0].AmDocs_tenantType__c == 'Individual' || ( O[0].AmDocs_tenantType__c == 'Incremental' && TA[0].AmDocs_ServiceID__c == null ) ) {
                    System.debug('DEBUG 004 ======== TenantType: ' + O[0].AmDocs_tenantType__c );
                    if(TA[i].First_Name__c != Null) {
                        jsonObj.writeStringField('customerFirstName', TA[i].First_Name__c);
                    }
                    if(TA[i].Last_Name__c != Null) {
                        jsonObj.writeStringField('customerLastName', TA[i].Last_Name__c);
                    }
                    jsonObj.writeStringField('phoneNumber', TA[i].Phone_Number__c);
                    if(TA[i].Email_Address__c != Null) {
                        jsonObj.writeStringField('emailAddress', TA[i].Email_Address__c);
                    }
                    
                    jsonObj.writeStringField('address', TA[i].Address__c);
                    jsonObj.writeStringField('unit', TA[i].Unit__c);
                    System.debug('DEBUG 004 ======== TA Unit: ' + TA[i].Unit__c );
                    jsonObj.writeStringField('city', TA[i].City__c);
                    jsonObj.writeStringField('state', TA[i].State__c);
                    jsonObj.writeStringField('zipCode', TA[i].Zip__c);
                }
            }
            
            jsonObj.writeFieldName('equipmentList');
            jsonObj.writeStartArray();   
            for(Integer i = 0; i < T.size(); i++){
                jsonObj.writeStartObject();
                jsonObj.writeStringField('action', 'ADD');
                jsonObj.writeStringField('receiverID', T[i].Name);
                jsonObj.writeStringField('smartCardID', T[i].Smart_Card__c);
                jsonObj.writeStringField('location', 'D');
                jsonObj.writeEndObject();
            }
            jsonObj.writeEndArray();
            
            if(O[0].AmDocs_tenantType__c == 'Individual') { 
                jsonObj.writeFieldName('attributeList');
                jsonObj.writeStartArray();
                for(Integer i = 0; i < TA.size(); i++){ 
                    if(TA[i].PPV__c == TRUE) { 
                        jsonObj.writeStartObject();
                        jsonObj.writeStringField('catalogCode', 'Enable_iPPV_Purchase');
                        jsonObj.writeStringField('selectedValue', 'Yes');
                        jsonObj.writeEndObject(); 
                    }
                    if(TA[i].PPV__c == FALSE) { 
                        jsonObj.writeStartObject();
                        jsonObj.writeStringField('catalogCode', 'Enable_iPPV_Purchase');
                        jsonObj.writeStringField('selectedValue', 'No');
                        jsonObj.writeEndObject(); 
                    }
                }
                jsonObj.writeEndArray();   }
            
            if(O[0].AmDocs_tenantType__c == 'Individual' ) { 
                jsonObj.writeFieldName('spsList');
                jsonObj.writeStartArray(); 
                for(Integer i = 0; i < TB.size(); i++){ 
                    jsonObj.writeStartObject();
                    jsonObj.writeStringField('action', TB[i].Action__c);
                    jsonObj.writeStringField('caption', TB[i].AmDocs_Individual_Caption__c);
                    jsonObj.writeEndObject(); 
                }
                jsonObj.writeEndArray();
                jsonObj.writeFieldName('componentList');
                jsonObj.writeStartArray();
                for(Integer i = 0; i < TP.size(); i++){
                    jsonObj.writeStartObject();
                    jsonObj.writeStringField('action', TP[i].Action__c);
                    jsonObj.writeStringField('caption', TP[i].AmDocs_Individual_Caption__c);
                    jsonObj.writeBooleanField('isPromotion', True);
                    jsonObj.writeEndObject(); 
                }
                jsonObj.writeEndArray();
            }                                      
            
            jsonObj.writeEndObject();
            jsonObj.writeEndObject();
            String finalJSON = jsonObj.getAsString();
            System.debug('DEBUG finalJSON: ' +finalJSON);   
            
            // if (!Test.isRunningTest()){ 
            HttpRequest request = new HttpRequest();
            String endpoint = A[0].End_Point_Environment__c+'/commerce/customer/'+O[0].AmDocs_CustomerID__c+'/createTV?sc=SS&lo=EN&ca=SF';
            request.setEndPoint(endpoint);
            request.setBody(jsonObj.getAsString());
            request.setHeader('Content-Type', 'application/json');
            request.setMethod('POST'); 
            String authorizationHeader = A[0].UXF_Token__c; request.setHeader('Authorization', authorizationHeader);
            request.setTimeout(101000);
            request.setHeader('User-Agent', 'SFDC-Callout/45.0'); 
            
            HttpResponse response = new HTTP().send(request); 
            if (response.getStatusCode() >= 200 && response.getStatusCode() <= 299) { 
                resultMsg='Success';
                String strjson = response.getbody();
                System.debug('DEBUG PRIOR to JSON DeSerialization ======== 1st STRING: ' +strjson);
                JSONParser parser = JSON.createParser(strjson);
                parser.nextToken(); parser.nextToken(); parser.nextToken();
                person obj = (person)parser.readValueAs( person.class);
                // Retrieve the Person object from the JSON string.
                System.debug(response.toString());
                System.debug('DEBUG STATUS:'+response.getStatus());
                System.debug('DEBUG STATUS_CODE:'+response.getStatusCode());
                System.debug('DEBUG 0 ======== 1st STRING: ' + strjson);
                System.debug('DEBUG 1 ======== obj.serviceID: ' + obj.tenantServiceID);
                System.debug('DEBUG 2 ======== obj.responseStatus: ' + obj.responseStatus);
                System.debug('DEBUG 6 ======== obj.orderID: ' + obj.orderID);
                
                // Products - CORE
                if(O[0].AmDocs_tenantType__c == 'Individual' ) { 
                    if(obj.responseStatus == 'SUCCESS') { 
                        if(TC.size() > 0) { 
                            for(Integer i = 0; i < TC.size(); i++) { 
                                Tenant_Product_Line_Item__c tcu = new Tenant_Product_Line_Item__c();
                                tcu.id=TC[i].id;
                                if(TC[i].Action__c == 'ADD') {
                                    tcu.Action__c = 'Active'; 
                                }
                                update tcu; 
                            }
                        }
                    }
                }
                // Products - Add-Ons
                if(TB.size() > 0) {
                    if(obj.responseStatus == 'SUCCESS') { 
                        for(Integer i = 0; i < TB.size(); i++) {
                            Tenant_Product_Line_Item__c tbu = new Tenant_Product_Line_Item__c();
                            tbu.id=TB[i].id; if(TB[i].Action__c == 'ADD') {
                                tbu.Action__c = 'Active'; 
                            }
                        }
                    }
                }
                // Products - Promotions
                if(TP.size() > 0) {
                    if(obj.responseStatus == 'SUCCESS') { 
                        for(Integer i = 0; i < TP.size(); i++) {
                            Tenant_Product_Line_Item__c tpu = new Tenant_Product_Line_Item__c();
                            tpu.id=TP[i].id; if(TP[i].Action__c == 'ADD') {
                                tpu.Action__c = 'Active'; 
                            } 
                            update tpu; 
                        } 
                    }
                }
                //    }
                // Tenant Equipment
                if(T.size() > 0) { 
                    if(obj.responseStatus == 'SUCCESS' && T.size() > 0 && obj.equipmentList.size() > 0 && obj.tenantServiceID != Null && obj.orderID != Null){ 
                        if(obj.equipmentList[0].receiverID != null){  
                            list<string> receverIds = new list<string>();  
                            for(cls_equipmentList tcu : obj.equipmentList){ 
                                if(tcu.receiverID != null){ 
                                    receverIds.add(tcu.receiverID);
                                } 
                            } 
                            if(receverIds != null) { 
                                List<Tenant_Equipment__c> allEQ = [SELECT Id, Action__c, Amdocs_Tenant_ID__c, Name FROM Tenant_Equipment__C WHERE Name in :receverIds AND Tenant_Account__c = :id]; 
                                if( allEQ.Size() > 0 ) { 
                                    for(Tenant_Equipment__c currentEQ : allEQ){  
                                        if( currentEQ.Action__c == 'ADD' ){ 
                                            currentEQ.Action__c = 'Active'; 
                                            if( obj.tenantServiceID != Null){ 
                                                currentEQ.Amdocs_Tenant_ID__c = obj.tenantServiceID;
                                            }
                                        } 
                                        else if( currentEQ.Action__c == 'REMOVE'){
                                            currentEQ.Action__c = 'Removed'; 
                                        } 
                                    } 
                                    update allEQ; 
                                } 
                            } 
                        } 
                    }
                }
                
                //Create API Log Entry
                API_Log__c apil = new API_Log__c();{
                    apil.Record__c=id;
                    apil.Object__c='Tenant Account';
                    apil.Status__c=obj.responseStatus;
                    apil.Results__c=response.getBody();
                    apil.API__c='Create Unit';
                    apil.User__c=UserInfo.getUsername();
                    apil.User_Error__c=TRUE;
                    insert apil;
                }
                objResultMessage.isError=false;
                objResultMessage.isResponseNull=false;
                objResultMessage.resultMessage='Response status: '+obj.responseStatus;
                Tenant_Account__c sbc = new Tenant_Account__c(); {
                    sbc.id=id; sbc.AmDocs_FullString_Return__c=strjson + ' ' + system.now();
                    sbc.AmDocs_Order_ID__c=obj.orderID;
                    sbc.API_Status__c=String.valueOf(response.getStatusCode()); 
                    
                    if(TA[0].AmDocs_ServiceID__c == Null && obj.tenantServiceID != Null  && obj.orderID != Null ) {  
                        sbc.AmDocs_ServiceID__c=obj.tenantServiceID;
                        sbc.Action__c = 'Active'; }
                    
                    if(obj.informationMessages == Null && obj.tenantServiceID != Null && obj.orderID != Null  && obj.backendErrorMessage == Null && obj.responseStatus != Null) {
                        sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ' +obj.responseStatus ; 
                        sbc.AmDocs_Transaction_Code__c=obj.responseStatus; }
                    
                    if(obj.informationMessages != Null && obj.tenantServiceID == Null && obj.orderID == Null  && obj.backendErrorMessage == Null && obj.responseStatus != Null) {
                        sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ' +obj.responseStatus +' ' +obj.informationMessages[0].errorDescription ; sbc.AmDocs_Transaction_Code__c=obj.responseStatus; }            
                    objResultMessage.isError=false;
                    objResultMessage.isResponseNull=false;
                    if(obj!=null)objResultMessage.resultMessage='CREATE SUBSCRIBER ' +obj.responseStatus;
                    if(obj!=null &&obj.informationMessages!=null&&obj.informationMessages.size()>0 )
                        objResultMessage.resultMessage+=' ' +obj.informationMessages[0].errorDescription;
                    update sbc; 
                }
            }
                        
            else if (response.getStatusCode() >= 300 && response.getStatusCode() <= 600){
                String strjson = response.getbody();
                System.debug('strjson '+strjson);
                objResultMessage.isError=true;
                objResultMessage.isResponseNull=false;
                objResultMessage.resultMessage=strjson;
                try{JSONParser parser = JSON.createParser(strjson);
                    parser.nextToken(); parser.nextToken(); parser.nextToken();
                    person obj = (person)parser.readValueAs( person.class);
                    // Retrieve the Person object from the JSON string.
                    System.debug(response.toString());
                    System.debug('DEBUG STATUS:'+response.getStatus());
                    System.debug('DEBUG STATUS_CODE:'+response.getStatusCode());
                    System.debug('DEBUG 0 ======== 1st STRING: ' + strjson);
                    System.debug('DEBUG 2 ======== obj.responseStatus: ' + obj.responseStatus);
                    
                    //Create API Log Entry
                    API_Log__c apil = new API_Log__c();{
                        apil.Record__c=id;
                        apil.Object__c='Tenant Account';
                        apil.Status__c=obj.responseStatus;
                        apil.Results__c=response.getBody();
                        apil.API__c='Create Unit';
                        apil.User__c=UserInfo.getUsername();
                        apil.User_Error__c=FALSE;
                        insert apil;
                    }
                    
                    Tenant_Account__c sbc = new Tenant_Account__c();{
                        sbc.id=id;
                        sbc.API_Status__c='ERROR - CREATE SUBSCRIBER ' +String.valueOf(response.getStatusCode());
                        objResultMessage.isError=true;
                        //Milestone# MS-001732 - 23 June 2020 - Start
                        //objResultMessage.resultMessage='ERROR - CREATE SUBSCRIBER ' +String.valueOf(response.getStatusCode());
                        objResultMessage.resultMessage='An unexpected error has occurred. Please contact your Salesforce Administrator.';
                        //Milestone# MS-001732 - End
                        sbc.AmDocs_FullString_Return__c=strjson + ' ' + system.now();
                        
                        if(obj.informationMessages != Null && obj.orderID == Null && obj.backendErrorMessage == Null ) { 
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ERROR ' +obj.informationMessages[0].errorDescription;
                            sbc.AmDocs_Transaction_Code__c=obj.informationMessages[0].errorCode; 
                            objResultMessage.isError=true;
                            //Milestone# MS-001732 - 23 June 2020 - Start
                            //objResultMessage.resultMessage='CREATE SUBSCRIBER ERROR ' +obj.informationMessages[0].errorDescription;
                            objResultMessage.resultMessage='An unexpected error has occurred. Please contact your Salesforce Administrator.';
                            //Milestone# MS-001732 - End
                        }
                        
                        
                        else if(obj.informationMessages == Null && obj.orderID == Null && obj.backendErrorMessage != Null) { 
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ERROR ' +obj.backendErrorMessage;
                            objResultMessage.isError=true;
                            //Milestone# MS-001732 - 23 June 2020 - Start
                            //objResultMessage.resultMessage='CREATE SUBSCRIBER ERROR ' +obj.backendErrorMessage;
                            objResultMessage.resultMessage='An unexpected error has occurred. Please contact your Salesforce Administrator.';
                            //Milestone# MS-001732 - End
                            if(obj.informationMessages == Null && obj.orderID == Null && obj.backendErrorCode != Null) { 
                                sbc.AmDocs_Transaction_Code__c=obj.backendErrorCode; 
                            }
                        }
                        
                        else if(obj.informationMessages == Null && obj.backendErrorMessage == Null && obj.tenantServiceID == Null && obj.orderID == Null) {
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER UNKNOWN ERROR Request - ' +strjson;
                            sbc.AmDocs_Transaction_Code__c='ERROR'; 
                            objResultMessage.isError=true;
                            //Milestone# MS-001732 - 23 June 2020 - Start
                            //objResultMessage.resultMessage='CREATE SUBSCRIBER UNKNOWN ERROR Request - ' +strjson;
                            objResultMessage.resultMessage='An unexpected error has occurred. Please contact your Salesforce Administrator.';
                            //Milestone# MS-001732 - 23 June 2020 - End
                        }
                        update sbc;
                    }
                    
                    System.debug(response.toString());
                    System.debug('DEBUG STATUS:'+response.getStatus());
                    System.debug('DEBUG STATUS_CODE:'+response.getStatusCode());
                   }catch(Exception exp){System.debug(exp);}
            }
            //Milestone# MS-001732 - 19 June 2020 - Start
            else if (response.getStatusCode() == Null){
                objResultMessage.isResponseNull=true;
            }
            //Milestone# MS-001732 - End
        }
        System.debug('resultMsg=['+resultMsg+']');
        return objResultMessage;
    }
    
    @future(callout=true)
    
    public static void AmDocsMakeCalloutCreateUnit(String Id) {
        
        list<Tenant_Account__c> TA = [select id, Name, City__c, State__c, Zip__c, Unit__c, Address__c, Email_Address__c, First_Name__c, Last_Name__c, Phone_Number__c, PPV__c, Opportunity__c, AmDocs_ServiceID__c from Tenant_Account__c where Id = :id AND (AmDocs_ServiceID__c = '' OR AmDocs_ServiceID__c = Null) Limit 1];
        System.debug('RESULTS of the LIST lookup to the Tenant Account object' +TA);
        
        
        list<Tenant_Equipment__c> T = [select id, Amdocs_Tenant_ID__c, Smart_Card__c, Name, Address__c, City__c, State__c, Zip_Code__c, Unit__c, Phone_Number__c, Email_Address__c, Customer_First_Name__c, Customer_Last_Name__c, Location__c, Action__c, Opportunity__c from Tenant_Equipment__c where Tenant_Account__c = :id  AND Action__c = 'ADD' AND Location__c = 'D'];
        System.debug('RESULTS of the LIST lookup to the Tenant Equipment object' +T);     
        
        
        String SO = [select Opportunity__c from Tenant_Account__c where Id = :id LIMIT 1 ].Opportunity__c ;
        System.debug('RESULTS of the LIST SO String to the Opp object ' +SO);
        
        list<Opportunity> O = [select id, Name, AmDocs_tenantType__c, AmDocs_ServiceID__c, AmDocs_SiteID__c, AmDocs_BarID__c, Amdocs_CustomerID__c from Opportunity where Id = :SO LIMIT 1 ];
        System.debug('RESULTS of the LIST lookup to the Opp object S From SOs ID ' +O);
        
        list<Tenant_Product_Line_Item__c> TC = [select id, Action__c, Quantity__c, Standard_Price__c, AmDocs_Incremental_Caption__c, AmDocs_Incremental_ProductID__c, AmDocs_Individual_Caption__c, AmDocs_ProductID__c, Family__c from Tenant_Product_Line_Item__c where Tenant_Account__c = :id AND Action__c = 'ADD' AND Family__c = 'Core' LIMIT 1];
        System.debug('RESULTS of the LIST lookup to the Core OpportunityLineItem records for TC ' +TC);
        
        list<Tenant_Product_Line_Item__c> TB = [select id, Action__c, Tenant_Account__c, Quantity__c, Standard_Price__c, AmDocs_Incremental_Caption__c, AmDocs_Incremental_ProductID__c, AmDocs_Individual_Caption__c, AmDocs_ProductID__c, Family__c from Tenant_Product_Line_Item__c where Tenant_Account__c = :id AND Action__c = 'ADD' AND Family__c = 'Add-On' ];
        System.debug('RESULTS of the LIST lookup to the non-Core & non-Promotional OpportunityLineItem records for TB ' +TB);
        
        list<Tenant_Product_Line_Item__c> TP = [select id, Action__c, Quantity__c, Tenant_Account__c, Standard_Price__c, AmDocs_Incremental_Caption__c, AmDocs_Incremental_ProductID__c, AmDocs_Individual_Caption__c, AmDocs_ProductID__c, Family__c from Tenant_Product_Line_Item__c where Tenant_Account__c = :id AND Action__c = 'ADD' AND Family__c = 'Promotion' ];
        System.debug('RESULTS of the LIST lookup to the Promotional OpportunityLineItem records for TP ' +TP);
        
        list<OpportunityLineItem> C = [select id, Action__c, Quantity, Sales_Price2__c, Amdocs_ProductID__c, Family__c, Opportunity.Id from OpportunityLineItem where Opportunity.Id = :SO AND Family__c = 'Core' LIMIT 1];
        System.debug('RESULTS of the LIST lookup to the Core OpportunityLineItem records' +C);
        
        list<AmDocs_Login__c> A = [select id, UserName__c, UserPassword__c, UXF_Token__c, End_Point_Environment__c, CreatedDate from AmDocs_Login__c Order By CreatedDate DESC Limit 1 ];
        System.debug('RESULTS of the LIST lookup to the OpportunityLineItem object' +A);  
        
        
        if(TA.size() < 1){
            
            //Create API Log Entry
            API_Log__c apil = new API_Log__c();{
                apil.Record__c=id;
                apil.Object__c='Tenant Account';
                apil.Status__c='ERROR';
                apil.Results__c='Can not CREATE UNIT if the UNIT -Tenant Service ID- already exists.';
                apil.API__c='Create Unit';
                apil.User__c=UserInfo.getUsername();
                apil.User_Error__c=TRUE;
                insert apil;
            }
            
            Tenant_Account__c sbc = new Tenant_Account__c();{
                sbc.id=id;
                sbc.API_Status__c='ERROR';
                sbc.AmDocs_Transaction_Description__c='ERROR - CREATE SUBSCRIBER - A Tenant Service ID Already Exists';
                update sbc;
            }
        }
        if(TA.size() > 0){
            
            
            if(T.size() < 1){
                
                //Create API Log Entry
                API_Log__c apil = new API_Log__c();{
                    apil.Record__c=id;
                    apil.Object__c='Tenant Account';
                    apil.Status__c='ERROR';
                    apil.Results__c='Can not create UNIT without Equipment. Please ADD Tenant Equipment.';
                    apil.API__c='Create Unit';
                    apil.User__c=UserInfo.getUsername();
                    apil.User_Error__c=TRUE;
                    insert apil;
                }
                
                Tenant_Account__c sbc = new Tenant_Account__c();{
                    sbc.id=id;
                    sbc.API_Status__c='ERROR';
                    sbc.AmDocs_Transaction_Description__c='Can not create UNIT without Equipment. Please ADD Tenant Equipment.';
                    update sbc;
                }
            }  
            if(T.size() > 0){
                
                JSONGenerator jsonObj = JSON.createGenerator(true);
                jsonObj.writeStartObject();
                jsonObj.writeFieldName('ImplCreateTVRestInput');
                jsonObj.writeStartObject();
                if(O[0].AmDocs_ServiceID__c != null && O[0].AmDocs_tenantType__c != 'Individual') { jsonObj.writeStringField('ownerServiceID', O[0].AmDocs_ServiceID__c);
                                                                                                   System.debug('DEBUG 001 ======== Service ID: ' + O[0].AmDocs_ServiceID__c );
                                                                                                  }
                jsonObj.writeStringField('reasonCode', 'CREQ');
                jsonObj.writeStringField('siteID', O[0].AmDocs_SiteID__c);
                System.debug('DEBUG 002 ======== AmDocs_SiteID: ' + O[0].AmDocs_SiteID__c );
                jsonObj.writeStringField('bar', O[0].AmDocs_BarID__c);
                for(Integer i = 0; i < TC.size(); i++){
                    if(O[0].AmDocs_tenantType__c == 'Individual') {jsonObj.writeStringField('productOfferID', TC[i].AmDocs_ProductID__c); }
                    else if(O[0].AmDocs_tenantType__c != 'Incremental') {jsonObj.writeStringField('productOfferID', TC[i].AmDocs_Incremental_ProductID__c); }}
                
                System.debug('DEBUG 003 ======== TenantType: ' + O[0].AmDocs_tenantType__c );
                for(Integer i = 0; i < TA.size(); i++){
                    if(O[0].AmDocs_tenantType__c == 'Individual' || ( O[0].AmDocs_tenantType__c == 'Incremental' && TA[0].AmDocs_ServiceID__c == null ) ) {
                        System.debug('DEBUG 004 ======== TenantType: ' + O[0].AmDocs_tenantType__c );
                        if(TA[i].First_Name__c != Null) {
                            jsonObj.writeStringField('customerFirstName', TA[i].First_Name__c);
                        }
                        if(TA[i].Last_Name__c != Null) {
                            jsonObj.writeStringField('customerLastName', TA[i].Last_Name__c);
                        }
                        jsonObj.writeStringField('phoneNumber', TA[i].Phone_Number__c);
                        if(TA[i].Email_Address__c != Null) {
                            jsonObj.writeStringField('emailAddress', TA[i].Email_Address__c);
                        }
                        
                        jsonObj.writeStringField('address', TA[i].Address__c);
                        jsonObj.writeStringField('unit', TA[i].Unit__c);
                        System.debug('DEBUG 004 ======== TA Unit: ' + TA[i].Unit__c );
                        jsonObj.writeStringField('city', TA[i].City__c);
                        jsonObj.writeStringField('state', TA[i].State__c);
                        jsonObj.writeStringField('zipCode', TA[i].Zip__c);
                    }
                }
                
                jsonObj.writeFieldName('equipmentList');
                jsonObj.writeStartArray();   
                for(Integer i = 0; i < T.size(); i++){
                    jsonObj.writeStartObject();
                    jsonObj.writeStringField('action', 'ADD');
                    jsonObj.writeStringField('receiverID', T[i].Name);
                    jsonObj.writeStringField('smartCardID', T[i].Smart_Card__c);
                    jsonObj.writeStringField('location', 'D');
                    jsonObj.writeEndObject();
                }
                jsonObj.writeEndArray();
                
                if(O[0].AmDocs_tenantType__c == 'Individual') { 
                    jsonObj.writeFieldName('attributeList');
                    jsonObj.writeStartArray();
                    for(Integer i = 0; i < TA.size(); i++){ 
                        if(TA[i].PPV__c == TRUE) { 
                            jsonObj.writeStartObject();
                            jsonObj.writeStringField('catalogCode', 'Enable_iPPV_Purchase');
                            jsonObj.writeStringField('selectedValue', 'Yes');
                            jsonObj.writeEndObject(); 
                        }
                        if(TA[i].PPV__c == FALSE) { 
                            jsonObj.writeStartObject();
                            jsonObj.writeStringField('catalogCode', 'Enable_iPPV_Purchase');
                            jsonObj.writeStringField('selectedValue', 'No');
                            jsonObj.writeEndObject(); 
                        }
                    }
                    jsonObj.writeEndArray();   }
                
                if(O[0].AmDocs_tenantType__c == 'Individual' ) { 
                    jsonObj.writeFieldName('spsList');
                    jsonObj.writeStartArray(); 
                    for(Integer i = 0; i < TB.size(); i++){ 
                        jsonObj.writeStartObject();
                        jsonObj.writeStringField('action', TB[i].Action__c);
                        jsonObj.writeStringField('caption', TB[i].AmDocs_Individual_Caption__c);
                        jsonObj.writeEndObject(); 
                    }
                    jsonObj.writeEndArray();
                    jsonObj.writeFieldName('componentList');
                    jsonObj.writeStartArray();
                    for(Integer i = 0; i < TP.size(); i++){
                        jsonObj.writeStartObject();
                        jsonObj.writeStringField('action', TP[i].Action__c);
                        jsonObj.writeStringField('caption', TP[i].AmDocs_Individual_Caption__c);
                        jsonObj.writeBooleanField('isPromotion', True);
                        jsonObj.writeEndObject(); 
                    }
                    jsonObj.writeEndArray();
                }                                      
                
                jsonObj.writeEndObject();
                jsonObj.writeEndObject();
                String finalJSON = jsonObj.getAsString();
                System.debug('DEBUG finalJSON: ' +finalJSON);   
                
                HttpRequest request = new HttpRequest();
                String endpoint = A[0].End_Point_Environment__c+'/commerce/customer/'+O[0].AmDocs_CustomerID__c+'/createTV?sc=SS&lo=EN&ca=SF';
                request.setEndPoint(endpoint);
                request.setBody(jsonObj.getAsString());
                request.setHeader('Content-Type', 'application/json');
                request.setHeader('Accept', 'application/json'); 
                request.setHeader('User-Agent', 'SFDC-Callout/45.0'); 
                request.setMethod('POST'); 
                String authorizationHeader = A[0].UXF_Token__c; request.setHeader('Authorization', authorizationHeader);
                request.setTimeout(101000);
                
                HttpResponse response = new HTTP().send(request); 
                if (response.getStatusCode() >= 200 && response.getStatusCode() <= 299) { 
                    String strjson = response.getbody();
                    System.debug('DEBUG PRIOR to JSON DeSerialization ======== 1st STRING: ' +strjson);
                    JSONParser parser = JSON.createParser(strjson);
                    parser.nextToken(); parser.nextToken(); parser.nextToken();
                    person obj = (person)parser.readValueAs( person.class);
                    // Retrieve the Person object from the JSON string.
                    System.debug(response.toString());
                    System.debug('DEBUG STATUS:'+response.getStatus());
                    System.debug('DEBUG STATUS_CODE:'+response.getStatusCode());
                    System.debug('DEBUG 0 ======== 1st STRING: ' + strjson);
                    System.debug('DEBUG 1 ======== obj.serviceID: ' + obj.tenantServiceID);
                    System.debug('DEBUG 2 ======== obj.responseStatus: ' + obj.responseStatus);
                    System.debug('DEBUG 6 ======== obj.orderID: ' + obj.orderID);
                    
                    // Products - CORE
                    if(O[0].AmDocs_tenantType__c == 'Individual' ) { 
                        if(obj.responseStatus == 'SUCCESS') { 
                            if(TC.size() > 0) { 
                                for(Integer i = 0; i < TC.size(); i++) { 
                                    Tenant_Product_Line_Item__c tcu = new Tenant_Product_Line_Item__c();
                                    tcu.id=TC[i].id;
                                    if(TC[i].Action__c == 'ADD') {
                                        tcu.Action__c = 'Active'; 
                                    }
                                    update tcu; 
                                }
                            }
                        }
                        
                        // Products - Add-Ons
                        if(TB.size() > 0) {
                            if(obj.responseStatus == 'SUCCESS') { for(Integer i = 0; i < TB.size(); i++) {            Tenant_Product_Line_Item__c tbu = new Tenant_Product_Line_Item__c();            tbu.id=TB[i].id; if(TB[i].Action__c == 'ADD') { tbu.Action__c = 'Active'; } update tbu;
                                                                                                         }
                                                                }
                        }
                        // Products - Promotions
                        if(TP.size() > 0) {
                            if(obj.responseStatus == 'SUCCESS') { for(Integer i = 0; i < TP.size(); i++) {                Tenant_Product_Line_Item__c tpu = new Tenant_Product_Line_Item__c();                tpu.id=TP[i].id; if(TP[i].Action__c == 'ADD') {tpu.Action__c = 'Active'; } update tpu; 
                                                                                                         } 
                                                                }
                        }
                    }
                    // Tenant Equipment
                    if(T.size() > 0) { if(obj.responseStatus == 'SUCCESS' && T.size() > 0 && obj.equipmentList.size() > 0 && obj.tenantServiceID != Null && obj.orderID != Null){ 
                        if(obj.equipmentList[0].receiverID != null){  list<string> receverIds = new list<string>();  for(cls_equipmentList tcu : obj.equipmentList){ 
                            if(tcu.receiverID != null){ receverIds.add(tcu.receiverID); } } 
                                                                    if(receverIds != null) { List<Tenant_Equipment__c> allEQ = [SELECT Id, Action__c, Amdocs_Tenant_ID__c, Name FROM Tenant_Equipment__C WHERE Name in :receverIds AND Tenant_Account__c = :id]; 
                                                                                            if( allEQ.Size() > 0 ) { for(Tenant_Equipment__c currentEQ : allEQ){  
                                                                                                if( currentEQ.Action__c == 'ADD' ){ 
                                                                                                    currentEQ.Action__c = 'Active'; 
                                                                                                    if( obj.tenantServiceID != Null){ 
                                                                                                        currentEQ.Amdocs_Tenant_ID__c = obj.tenantServiceID;} } 
                                                                                                else if( currentEQ.Action__c == 'REMOVE'){currentEQ.Action__c = 'Removed'; } } update allEQ; } } } 
                    }
                                     }
                    
                    //Create API Log Entry
                    API_Log__c apil = new API_Log__c();{
                        apil.Record__c=id;
                        apil.Object__c='Tenant Account';
                        apil.Status__c=obj.responseStatus;
                        apil.Results__c=response.getBody();
                        apil.API__c='Create Unit';
                        apil.User__c=UserInfo.getUsername();
                        apil.User_Error__c=TRUE;
                        insert apil;
                    }
                    
                    Tenant_Account__c sbc = new Tenant_Account__c(); {
                        sbc.id=id; sbc.AmDocs_FullString_Return__c=strjson + ' ' + system.now();
                        sbc.AmDocs_Order_ID__c=obj.orderID;
                        sbc.API_ID__c=obj.tenantApID;
                        sbc.API_Status__c=String.valueOf(response.getStatusCode()); 
                        
                        if(TA[0].AmDocs_ServiceID__c == Null && obj.tenantServiceID != Null  && obj.orderID != Null ) {  
                            sbc.AmDocs_ServiceID__c=obj.tenantServiceID;
                            sbc.Action__c = 'Active'; }
                        
                        if(obj.informationMessages == Null && obj.tenantServiceID != Null && obj.orderID != Null  && obj.backendErrorMessage == Null && obj.responseStatus != Null) {
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ' +obj.responseStatus ; 
                            sbc.AmDocs_Transaction_Code__c=obj.responseStatus; }
                        
                        if(obj.informationMessages != Null && obj.tenantServiceID == Null && obj.orderID == Null  && obj.backendErrorMessage == Null && obj.responseStatus != Null) {            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ' +obj.responseStatus +' ' +obj.informationMessages[0].errorDescription ; sbc.AmDocs_Transaction_Code__c=obj.responseStatus; }            
                        
                        update sbc; }
                }
                
                
                
                else if ((response.getStatusCode() >= 300 && response.getStatusCode() <= 600) || response.getStatusCode() == Null)  {
                    String strjson = response.getbody();
                    JSONParser parser = JSON.createParser(strjson);
                    parser.nextToken(); parser.nextToken(); parser.nextToken();
                    person obj = (person)parser.readValueAs( person.class);
                    // Retrieve the Person object from the JSON string.
                    System.debug(response.toString());
                    System.debug('DEBUG STATUS:'+response.getStatus());
                    System.debug('DEBUG STATUS_CODE:'+response.getStatusCode());
                    System.debug('DEBUG 0 ======== 1st STRING: ' + strjson);
                    System.debug('DEBUG 2 ======== obj.responseStatus: ' + obj.responseStatus);
                    
                    //Create API Log Entry
                    API_Log__c apil = new API_Log__c();{
                        apil.Record__c=id;
                        apil.Object__c='Tenant Account';
                        apil.Status__c=obj.responseStatus;
                        apil.Results__c=response.getBody();
                        apil.API__c='Create Unit';
                        apil.User__c=UserInfo.getUsername();
                        apil.User_Error__c=FALSE;
                        insert apil;
                    }
                    
                    Tenant_Account__c sbc = new Tenant_Account__c();{
                        sbc.id=id;
                        sbc.API_Status__c='ERROR - CREATE SUBSCRIBER ' +String.valueOf(response.getStatusCode());
                        
                        sbc.AmDocs_FullString_Return__c=strjson + ' ' + system.now();
                        
                        if(obj.informationMessages != Null && obj.orderID == Null && obj.backendErrorMessage == Null ) { 
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ERROR ' +obj.informationMessages[0].errorDescription;
                            sbc.AmDocs_Transaction_Code__c=obj.informationMessages[0].errorCode; }
                        
                        else if(obj.informationMessages == Null && obj.orderID == Null && obj.backendErrorMessage != Null) { 
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER ERROR ' +obj.backendErrorMessage;
                            if(obj.informationMessages == Null && obj.orderID == Null && obj.backendErrorCode != Null) { 
                                sbc.AmDocs_Transaction_Code__c=obj.backendErrorCode; }}
                        
                        else if(obj.informationMessages == Null && obj.backendErrorMessage == Null && obj.tenantServiceID == Null && obj.orderID == Null) {
                            sbc.AmDocs_Transaction_Description__c='CREATE SUBSCRIBER UNKNOWN ERROR Request - ' +strjson;
                            sbc.AmDocs_Transaction_Code__c='ERROR'; }
                        
                        update sbc;
                    }
                    
                    
                    System.debug(response.toString());
                    System.debug('DEBUG STATUS:'+response.getStatus());
                    System.debug('DEBUG STATUS_CODE:'+response.getStatusCode());
                }
            }
        }
    }
}